Index: trunk/LMDZ.TITAN/libf/chimtitan/comp.c
===================================================================
--- trunk/LMDZ.TITAN/libf/chimtitan/comp.c	(revision 1121)
+++ trunk/LMDZ.TITAN/libf/chimtitan/comp.c	(revision 1126)
@@ -4,8 +4,19 @@
 #include "titan.h"
 
-void comp_(char CORPS[][10], double *MASS)
+void comp_(char CORPS[][10], double *CT, double *TEMP, 
+           double *MASS, double MD[][NLEV])
 {
-   int   i;
-   char  corps[100][10];
+   int   i,j;
+   char  corps[NC+1][10];
+
+   double m,ma,epsa,sig,siga,p;
+
+   p         = 2.976e07;   /*9 10^7 R / 8 pi */
+
+      /* WARNING BACKGROUND GAS IS N2 */
+
+   ma   = 28.0134e0;               /* mass of background gas in g */
+   siga = 3.798e0;         /* Lennard-Jones length of background gas 1/10 nm */
+   epsa = 71.4e0;       /* Lennard-Jones energy of background gas */
 
    for( i = 0; i <= NC; i++)
@@ -15,4 +26,9 @@
    }
 
+   for( i = 0; i <= NC-1; i++)
+   {
+      for( j = 0; j <= NLEV-1; j++ ) MD[i][j] = 0.0e0;
+   }
+
    for( i = 0; i <= NC-1; i++ )
    {
@@ -20,4 +36,9 @@
       {
          MASS[i] = 16.04e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 3.758e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m )
+           / ( CT[j] * sig * omega(TEMP[j],epsa,148.6e0) );
       }
       if( strcmp(corps[i], "H") == 0 )
@@ -28,128 +49,264 @@
       {
          MASS[i] = 2.0158e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 2.827e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m )
+           / ( CT[j] * sig * omega(TEMP[j],epsa,59.7e0) );
       }
       if( strcmp(corps[i], "CH") == 0 )
       {
          MASS[i] = 13.02e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 3.0e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( ( strcmp( corps[i], "CH2" ) == 0 ) || ( strcmp( corps[i], "CH2s" ) == 0 ) )
       {
          MASS[i] = 14.03e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 3.4e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "CH3") == 0 )
       {
          MASS[i] = 15.03e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 3.7e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "C") == 0 )
       {
          MASS[i] = 12.01e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 1.4e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "C2") == 0 )
       {
          MASS[i] = 24.02e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 3.2e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "C2H") == 0 )
       {
          MASS[i] = 25.03e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 3.5e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "C2H3") == 0 )
       {
          MASS[i] = 27.05e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 3.8e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "C2H4") == 0 )
       {
          MASS[i] = 28.05e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.163e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m )
+           / ( CT[j] * sig * omega(TEMP[j],epsa,224.7e0) );
       }
       if( strcmp(corps[i], "C2H2") == 0 )
       {
          MASS[i] = 26.04e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.033e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m )
+           / ( CT[j] * sig * omega(TEMP[j],epsa,231.8e0) );
       }
       if( strcmp(corps[i], "C2H5") == 0 )
       {
          MASS[i] = 29.06e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.0e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "C2H6") == 0 )
       {
          MASS[i] = 30.07e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.443e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m )
+           / ( CT[j] * sig * omega(TEMP[j],epsa,215.7e0) );
       }
       if( strcmp(corps[i], "C3H2") == 0 )
       {
          MASS[i] = 38.05e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.6e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "C3H3") == 0 )
       {
          MASS[i] = 39.06e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.7e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( ( strcmp(corps[i], "CH2CCH2") == 0 ) || ( strcmp(corps[i], "CH3CCH") == 0 ) )
       {
          MASS[i] = 40.07e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.761e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m )
+           / ( CT[j] * sig * omega(TEMP[j],epsa,251.8e0) );
       }
       if( strcmp(corps[i], "C3H5") == 0 )
       {
          MASS[i] = 41.07e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.78e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "C3H6") == 0 )
       {
          MASS[i] = 42.08e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.807e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m )
+           / ( CT[j] * sig * omega(TEMP[j],epsa,248.9e0) );
       }
       if( strcmp(corps[i], "C3H7") == 0 )
       {
          MASS[i] = 43.09e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 5.0e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
        }
       if( strcmp(corps[i], "C3H8") == 0 )
       {
          MASS[i] = 44.11e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 5.118e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m )
+           / ( CT[j] * sig * omega(TEMP[j],epsa,237.1e0) );
       }
       if( strcmp(corps[i], "C4H") == 0 )
       {
          MASS[i] = 49.05e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.2e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( ( strcmp(corps[i], "C4H2") == 0 )||( strcmp(corps[i], "C4H2s") == 0 ) )
       {
          MASS[i] = 50.06e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.3e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "C4H3") == 0 )
       {
          MASS[i] = 51.07e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.4e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "C4H4") == 0 )
       {
          MASS[i] = 52.08e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.5e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "C4H5") == 0 )
       {
          MASS[i] = 53.07e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.5e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "C4H6") == 0 )
       {
          MASS[i] = 54.09e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.6e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "C4H10") == 0 )
       {
          MASS[i] = 58.13e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.687e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m )
+           / ( CT[j] * sig * omega(TEMP[j],epsa,531.4e0) );
       }
       if( strcmp(corps[i], "C6H") == 0 )
       {
          MASS[i] = 73.07e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 5.2e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "C6H2") == 0 )
       {
          MASS[i] = 74.08e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 5.4e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "C8H2") == 0 )
       {
          MASS[i] = 98.10e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 6.0e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp( corps[i], "AC6H6" ) == 0 )
       {
          MASS[i] = 78.1136e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 5.4e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )   /* P. G. L. */
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( ( strcmp( corps[i], "C6H5" ) == 0 ) || ( strcmp( corps[i], "AC6H5" ) == 0 ) )
       {
          MASS[i] = 77.1136e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 5.4e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp( corps[i], "C6H6" ) == 0 )
       {
          MASS[i] = 78.1136e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 5.4e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "N2") == 0 )
@@ -160,96 +317,230 @@
       {
          MASS[i] = 14.01e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 1.5e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "NH") == 0 )
       {
          MASS[i] = 15.01e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 3.0e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "CN") == 0 )
       {
          MASS[i] = 26.02e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 3.2e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "HCN") == 0 )
       {
          MASS[i] = 27.04e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 3.63e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m )
+           / ( CT[j] * sig * omega(TEMP[j],epsa,569.1e0) );
       }
       if( strcmp(corps[i], "H2CN") == 0 )
       {
          MASS[i] = 28.05e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 3.8e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "C2N") == 0 )         /* C2N */
       {
          MASS[i] = 39.05e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.0e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp( corps[i], "CHCN" ) == 0 )
       {
          MASS[i]   = 39.05e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.0e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp( corps[i], "CH2CN" ) == 0 )
       {
          MASS[i]   = 40.04e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.0e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp( corps[i], "CH3CN" ) == 0 )
       {
          MASS[i]   = 41.05e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.0e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp( corps[i], "C2H3CN" ) == 0 )
       {
          MASS[i]   = 53.06e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.0e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "NCCN") == 0 )        /* NCCN */
       {
          MASS[i] = 52.04e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.361e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m )
+           / ( CT[j] * sig * omega(TEMP[j],epsa,348.6e0) );
       }
       if( strcmp(corps[i], "C3N") == 0 )         /* C3N */
       {
          MASS[i] = 50.04e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.4e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "HC3N") == 0 )        /* HC3N */
       {
          MASS[i] = 51.05e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.5e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp( corps[i], "C4N2" ) == 0 )
       {
          MASS[i]   = 76.1e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.0e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "H2O") == 0 )       
       {
          MASS[i] = 18.02e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 2.641e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) 
+           / ( CT[j] * sig * omega(TEMP[j],epsa,809.1e0) );
       }
       if( ( strcmp(corps[i], "O3P") == 0 ) || ( strcmp(corps[i], "O1D") == 0 ) )      
       {
          MASS[i] = 16.0e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 1.4e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "OH") == 0 )        
       {
          MASS[i] = 17.01e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 3.0e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
+      }
+      if( strcmp(corps[i], "HO2") == 0 )
+      {
+         MASS[i] = 33.01e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 3.5e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
+      }
+      if( strcmp(corps[i], "H2O2") == 0 )
+      {
+         MASS[i] = 33.01e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 3.5e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
+      }
+      if( strcmp(corps[i], "O2") == 0 )
+      {
+         MASS[i] = 32.0e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 3.7e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
+      }
+      if( strcmp(corps[i], "O3") == 0 )
+      {
+         MASS[i] = 32.0e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 3.7e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "CO") == 0 )          
       {
          MASS[i] = 28.01e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 3.69e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m )
+           / ( CT[j] * sig * omega(TEMP[j],epsa,91.7e0) );
       }
       if( strcmp(corps[i], "HCO") == 0 )        
       {
          MASS[i] = 29.02e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 3.7e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "CO2") == 0 )       
       {
          MASS[i] = 44.01e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 3.941e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) 
+           / ( CT[j] * sig * omega(TEMP[j],epsa,195.2e0) );
       }
       if( strcmp(corps[i], "CH2CO") == 0 )    
       {
          MASS[i] = 42.04e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 4.5e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "CH2O") == 0 )    
       {
          MASS[i] = 30.03e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 3.75e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( ( strcmp(corps[i], "CH2OH") == 0 ) || ( strcmp(corps[i], "CH3O") == 0 ) )  
       {
          MASS[i] = 31.04e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 3.4e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m ) / ( CT[j] * sig );
       }
       if( strcmp(corps[i], "CH3OH") == 0 )       
       {
          MASS[i] = 32.042e0;
+         m       = ( ma + MASS[i] ) / ( ma * MASS[i] );
+         sig     = 1.0e-16 * pow( ( siga + 3.626e0 ), 2.0e0 );
+         for( j = 0; j <= NLEV-1; j++ )
+            MD[i][j] = sqrt( p * TEMP[j] * m )
+           / ( CT[j] * sig * omega(TEMP[j],epsa,481.8e0) );
       }
    }
Index: trunk/LMDZ.TITAN/libf/chimtitan/disso.c
===================================================================
--- trunk/LMDZ.TITAN/libf/chimtitan/disso.c	(revision 1121)
+++ trunk/LMDZ.TITAN/libf/chimtitan/disso.c	(revision 1126)
@@ -7,5 +7,5 @@
 #include "titan.h"
 
-void disso_( double KRPD[][NLEV][RDISS+1][15], int *NLAT )
+void disso_( double KRPD[][NLRT][RDISS+1][15], int *NLAT )
 {
    static double sH2[62] = {  /* incertain en dessous de 70 et en dessus de 85... */
@@ -179,11 +179,26 @@
    double f,**flux;
    double flact;
-   char   name[60];
+   char   name[60],dir[24];
    FILE   *fp,*out;
 
-   flux = dm2d(0,NLEV,0,14);
-
+   flux = dm2d(0,NLRT,0,14);
+
+/* lecture des flux actiniques:
+   - suppose que l'executable est dans $LMDGCM/RUN/xxx/
+   - et les moyennes dans $LMDGCM/INPUT/PHOT(NLAT)/Moy_(lat:1 a NLAT)
+*/
+   strcpy( dir, "../../INPUT/PHOT" );
+   if( (*NLAT) < 10 )
+   {
+     strcat( dir, "0"  );
+     strcat( dir, (const char *)ecvt((float)(*NLAT),1,&x,&x) );
+   }
+   else 
+     strcat( dir, (const char *)ecvt((float)(*NLAT),2,&x,&x) );
+   strcat( dir, "x/Moy_"  );
+   printf( "Directories for actinic fluxes: %s \n", dir );
+ 
    for( lat = 0; lat <= (*NLAT)-1; lat++ )   /* Old array is set equal to 0. */
-     for( j = 0; j <= NLEV-1; j++ )
+     for( j = 0; j <= NLRT-1; j++ )
        for( i = 0; i <= RDISS; i++ )                  
          for( s = 0; s <= 14; s++ )
@@ -195,15 +210,8 @@
    for( i = 0; i <= 16; i++ ) sC2H6[i] = 0.0e0;
 
-//   for( lat = 25; lat <= 25; lat++ )     /* Main loop on latitude */
    for( lat = 0; lat <= (*NLAT)-1; lat++ ) /*     Main loop on latitude */
    for( i = 10; i <= 310; i += 5 )             /* Main loop on wavelength. */
    {
-/* lecture des flux actiniques:
-   - suppose que l'executable est dans $LMDGCM/RUN/xxx/
-   - et les moyennes dans GCCM/INPUT/PHOT(NLAT)/Moy_(lat:1 a NLAT)
-   (sauf a l'idris...)
-*/
-      strcpy( name, "../../INPUT/PHOT49/Moy_" ); 
-//    strcpy( name, "PHOT49/Moy_" ); 
+      strcpy( name, dir ); 
       if( (lat+1) < 10 )
       {
@@ -213,6 +221,6 @@
       else 
        strcat( name, (const char *)ecvt((float)(lat+1),2,&x,&x) );
-      if( i < 160 ) strcat( name, "/photgcm3a" );
-      else          strcat( name, "/photgcm3a" );
+      if( i < 160 ) strcat( name, "/photmoy3a" );
+      else          strcat( name, "/photmoy3a" );
       if( i < 100 )
       {
@@ -232,5 +240,5 @@
          exit(0);
       }
-      for( j = 0; j <= NLEV-1; j++ )
+      for( j = 0; j <= NLRT-1; j++ )
       {
          fscanf( fp,"%d ",&l );
@@ -248,5 +256,5 @@
 
       for( s = 0; s <= 14; s++ )
-       for( j = 0; j <= NLEV-1; j++ )
+       for( j = 0; j <= NLRT-1; j++ )
        {
          f = flux[j][s] * sol[l] / ( 9.5e0 * 9.5e0 );   /* !! # de reac de 0 a RDISS-1 !! */
@@ -369,11 +377,11 @@
     for( s = 0; s <= 14; s++ )
     {
-     for( j = 36; j <= NLEV-1; j++ )  /* level 36 ~ 200 km */
+     for( j = 99; j <= NLRT-1; j++ )  /* level 100 = 200 km */
       KRPD[lat][j][RDISS][s] = 1.0e-16;
-     for( j = 26; j <= 35; j++ )      /* level 26 ~ 100 km */
-      KRPD[lat][j][RDISS][s] = 1.0e-17+9.e-18*(j-26);
-     for( j = 23; j <= 25; j++ )      /* level 23 ~ 70 km */
-      KRPD[lat][j][RDISS][s] = pow(10.,(-23+2*(j-23)));
-     for( j = 0; j <= 22; j++ )
+     for( j = 49; j <= 98; j++ )      /* level 50 = 100 km */
+      KRPD[lat][j][RDISS][s] = 1.0e-17+1.8e-18*(j-49);
+     for( j = 34; j <= 48; j++ )      /* level 35 = 70 km */
+      KRPD[lat][j][RDISS][s] = pow(10.,(-23+0.4*(j-34)));
+     for( j = 0; j <= 33; j++ )
       KRPD[lat][j][RDISS][s] = 0.0e0;
     }
